#include "Platform.h"

#include "MatrixEve2Conf.h" // Matrix Orbital EVE library
#include "hw_api.h"         // Matrix Orbital EVE library      
#include "Eve2_81x.h"       // Matrix Orbital EVE library 

#define MyDelay _waitms
#define Log  printf

#include "Eve2_81x.c"       // Matrix Orbital EVE library 

int Display_Width()
{
    return HSIZE;
}

int Display_Height()
{
    return VSIZE;
}

void MakeScreen_MatrixOrbital(uint8_t DotSize)
{

    Send_CMD(CMD_DLSTART);                   // Start a new display list
    Send_CMD(CLEAR_COLOR_RGB(255, 0, 0));      // Determine the clear screen color
    Send_CMD(CLEAR(1, 1, 1));                // Clear the screen and the curren display lis

    
    Send_CMD(COLOR_RGB(26, 26, 192));        // change colour to blue
    Send_CMD(POINT_SIZE(DotSize * 16));      // set point size to DotSize pixels. Points = (pixels x 16)
    Send_CMD(BEGIN(POINTS));                 // start drawing point
    Send_CMD(TAG(1));                        // Tag the blue dot with a touch ID
    Send_CMD(VERTEX2II(Display_Width() / 2, (Display_Height() / 2) - 60, 0, 0));     // place blue point
    Send_CMD(END());                         // end drawing point
    Send_CMD(COLOR_RGB(255, 255, 255));      // Change color to white for text
    Cmd_Text(Display_Width() / 2, (Display_Height() / 2) - 60, 30, OPT_CENTER, " MATRIX         ORBITAL"); //Write text in the center of the screen
    Cmd_Text(Display_Width() / 2, (Display_Height() / 2), 28, OPT_CENTER, "Connecting to WIFI"); //Write text in the center of the screen
    Cmd_Spinner(Display_Width() / 2, 80 + (Display_Height() / 2), 0, 0);
    Send_CMD(DISPLAY());                     // End the display list
    Send_CMD(CMD_SWAP);                      // Swap commands into RAM
    UpdateFIFO();                            // Trigger the CoProcessor to start processing the FIFO
    Wait4CoProFIFOEmpty();                   // wait here until the coprocessor has read and executed every pending command.    
}



void setup()
{

    GlobalInit();
    printf("ftinit..\n");
    FT81x_Init();

    //if (FlashAttach())
    //{
    //    uint32_t FlashSize = rd32(REG_FLASH_SIZE + RAM_REG);   // Flash size is reported in megabytes.
    //    printf("flash Size = %d mbytes (%d mbits)\n", FlashSize, FlashSize * 8);

    //    // You can only display images from flash if the flash is running in full speed mode
    //    // which you enter by the CMD_FLASHFAST command. 
    //    if (!FlashFast())
    //    {
    //        printf("Still unable to enter fast mode...please power cycle the unit\n");
    //    }

    //    uint8_t FlashStatus = rd8(REG_FLASH_STATUS + RAM_REG);
    //    printf("Flash Full Speed : %s\n", FlashStatus == FLASH_STATUS_FULL ? "yes" : "no");
    //}

}


// ************************************************************************************
// Following are wrapper functions for C++ Arduino functions so that they may be      *
// called from outside of C++ files.  These are also your opportunity to use a common *
// name for your hardware functions - no matter the hardware.  In Arduino-world you   *
// interact with hardware using Arduino built-in functions which are all C++ and so   *
// your "abstraction layer" must live in this xxx.ino file where C++ works.           *
//                                                                                    *
// Incidentally, this is also an alternative to ifdef-elif hell.  A different target  *
// processor or compiler will include different files for hardware abstraction, but   *
// the core "library" files remain unaltered - and clean.  Applications built on top  *
// of the libraries need not know which processor or compiler they are running /      *
// compiling on (in general and within reason)                                        *
// ************************************************************************************

void GlobalInit(void)
{

}


void DebugPrint(char* str)
{
    printf(str);
}

void main()
{
    setup();
    printf("Showing Matrix Orbital Screen\n");
    MakeScreen_MatrixOrbital(16);
    printf("Done.\n");
    for (;;) {}
}
